<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from lic.texi on 28 April 1999 -->

<TITLE>The Linear Inequality Calculator - Find Existence of Communication</TITLE>
<link href="lic_14.html" rel=Next>
<link href="lic_12.html" rel=Previous>
<link href="lic_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="lic_1.html">first</A>, <A HREF="lic_12.html">previous</A>, <A HREF="lic_14.html">next</A>, <A HREF="lic_21.html">last</A> section, <A HREF="lic_toc.html">table of contents</A>.
<P><HR><P>


<H3><A NAME="SEC13" HREF="lic_toc.html#TOC13">Find Existence of Communication</A></H3>


<PRE>
 A(N,N), B(N,N)
 DISTRIBUTE (*,BLOCK) A, B
 do i = 2, N-1
   do j = i, N-1
     A(i, j) = A(i-1, j-1)
   enddo
 enddo
</PRE>

<P>
<A NAME="IDX149"></A>

</P>
<P>
For the above loop nest the owner computers rule finds the computation
decomposition.  See section <A HREF="lic_12.html#SEC12">Owner Computes Rule</A>. In this example, the
communication needed by the read access is found.  Communication is
needed when the data used by the read access is not in the processor
executing the iteration. Since the operator <CODE>Ps != Pr</CODE> is not
convex, the problem is divided into two subproblems; <CODE>Ps &#62; Pr</CODE> and
<CODE>Ps &#60; Pr</CODE>.

</P>
<P>
<A NAME="IDX150"></A>
<A NAME="IDX151"></A>
<A NAME="IDX152"></A>
<A NAME="IDX153"></A>
<A NAME="IDX154"></A>
<A NAME="IDX155"></A>

</P>

<PRE>
iterl = [2 &#60;= i &#60;= N - 1
        i &#60;= j &#60;= N - 1]

dist = [blk*Ps &#60;= bsy &#60; blk*Ps + blk 
        blk*Pr &#60;= bry &#60; blk*Pr + blk ]

lhs = [bsx = i
       bsy = j ]

rhs = [brx = i
       bry = j - 1 ]

#res = {iter, dist, lhs, rhs}

#comm1 = { res
          [ Ps &#60; Pr ] }
comm1.realsol()

#comm2 = { res
          [ Ps &#62; Pr ] }
comm2.realsol()

end
</PRE>

<P>
<A NAME="IDX156"></A>

</P>
<P>
The printout of the example session:

</P>

<PRE>
csh&#62; lic -c
Rapid Prototyping System for Code Generation
&#62; &#60; example4
iterl = [2 &#60;= i &#60;= N - 1
        i &#60;= j &#60;= N - 1]
-1+N-j &#62;= 0
j-i &#62;= 0
-1+N-i &#62;= 0
-2+i &#62;= 0

dist = [blk*Ps &#60;= bsy &#60; blk*Ps + blk
        blk*Pr &#60;= bry &#60; blk*Pr + blk ]
-1+blk+blk*Pr-bry &#62;= 0
-blk*Pr+bry &#62;= 0
-1+blk+blk*Ps-bsy &#62;= 0
-blk*Ps+bsy &#62;= 0

lhs = [bsx = i
       bsy = j ]
bsy-j &#62;= 0
-bsy+j &#62;= 0
bsx-i &#62;= 0
-bsx+i &#62;= 0

rhs = [brx = i
       bry = j - 1 ]
1+bry-j &#62;= 0
-1-bry+j &#62;= 0
brx-i &#62;= 0
-brx+i &#62;= 0

#res = {iter, dist, lhs, rhs}

#comm1 = { res
          [ Ps &#60; Pr ] }
comm1.realsol()
0

#comm2 = { res
          [ Ps &#62; Pr ] }
comm2.realsol()
1

end
&#62; quit
done(0)

csh&#62;
</PRE>

<P>
<A NAME="IDX157"></A>

</P>

<P><HR><P>
<p>Go to the <A HREF="lic_1.html">first</A>, <A HREF="lic_12.html">previous</A>, <A HREF="lic_14.html">next</A>, <A HREF="lic_21.html">last</A> section, <A HREF="lic_toc.html">table of contents</A>.
</BODY>
</HTML>
